<?php //header('Content-Type: text/html; charset=utf-8');
define('ANBLOG_TURBOYA_DIR', plugin_dir_path(__FILE__));
define('ANBLOG_TURBOYA_URL', plugin_dir_url(__FILE__));

global $wpdb;
echo '<link rel="stylesheet" href="'.ANBLOG_TURBOYA_URL.'css/style.css" type="text/css" />'.PHP_EOL;
echo '<script src="'.ANBLOG_TURBOYA_URL.'js/script.js" type="text/javascript"></script>'.PHP_EOL;




$wpdb->query("create table IF NOT EXISTS anblog_turboya (id int not null AUTO_INCREMENT, title TEXT(100000) not null, link TEXT(100000) not null, description TEXT(100000) not null, ya_analytic TEXT(100000) not null, on_post TEXT(100000) not null, on_page TEXT(100000) not null, on_thumbnail TEXT(100000) not null, on_description TEXT(100000) not null, on_yandex_genre TEXT(100000) not null, yandex_genre TEXT(100000) not null, on_author TEXT(100000) not null, file_name TEXT(100000) not null, PRIMARY KEY(id)  ) DEFAULT CHARACTER SET utf8 ");
$first = $wpdb->get_results("SELECT * FROM anblog_turboya");
if (empty($first)) {

$first_title        = $wpdb->get_results("SELECT * FROM wp_options WHERE option_name = 'blogname'");
$first_link         = $wpdb->get_results("SELECT * FROM wp_options WHERE option_name = 'siteurl'");
$first_description  = $wpdb->get_results("SELECT * FROM wp_options WHERE option_name = 'blogdescription'");
$wpdb->insert('anblog_turboya',	array('title' => $first_title[0]->option_value, 'link' => $first_link[0]->option_value, 'description' => $first_description[0]->option_value, 'on_post' => '1', 'on_page' => '1', 'on_thumbnail' => '1', 'on_description' => '1', 'on_yandex_genre' => '1', 'yandex_genre' => 'article', 'on_author' => '1', 'file_name' => mt_rand().'.rss'), array( '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s' ) );
}



?>
<div class="wrap">
<div class="wrap">
<div class="adminp4">
<div class="adminp2">
<?php $main = $wpdb->get_results("SELECT * FROM anblog_turboya where id = '1'"); ?>
<form method="post" enctype="multipart/form-data" action="" name="phuploader">
<div class="adminp8">
<h1 style="padding-bottom: 25px;">Яндекс - турбо страницы</h1>
<div class="adminp9text">Плагин создаст в корне вашего сайта файл с именем <a href="/<?=$main[0]->file_name?>" target="_blank"><?=$main[0]->file_name?></a></div>
<div class="adminp9">
<div class="adminp9label">Настройки ленты</div>
<div class="adminp9text">Домен сайта * <span>Например: http://blogprogram.ru</span> <input type="text" name="link" required value="<?=$main[0]->link?>"></div>
<div class="adminp9text">Название RSS-канала * <span>Максимальная длина заголовка - 200 символов</span> <textarea required name="title" maxlength="200"><?=$main[0]->title?></textarea></div>
<div class="adminp9text">Описание канала одним предложением * <span>Не используйте HTML-разметку.</span> <textarea required name="description" maxlength="150"><?=$main[0]->description?></textarea></div>
<div class="adminp9text">Номер Яндекс счетчика <span>Счетчик системы статистики для учета посещаемости Турбо-страниц</span> <input type="text" name="ya_analytic" placeholder="Например: 34803491" value="<?=$main[0]->ya_analytic?>"></div>
<div class="adminp9text">Имя rss файла * <span>Допумкаются цифры и латин-е символы</span> <input type="text" required name="file_name" placeholder="Например: 567rd.rss" value="<?=$main[0]->file_name?>"></div>
</div>
<div class="adminp9">
<div class="adminp9label">Настройки постов/страниц</div>
<div class="adminp9chec">Посты <div class="checktext"><input type="checkbox" id="on_post" name="on_post" <?=($main[0]->on_post == 1) ? 'checked="checked"' : ''?>><label for="on_post">Включить в rss</label></div></div>
<div class="adminp9chec">Одиночные страницы <div class="checktext"><input type="checkbox" id="on_page" name="on_page" <?=($main[0]->on_page == 1) ? 'checked="checked"' : ''?>><label for="on_page">Включить в rss</label></div></div>
<div class="adminp9chec">Миниатюра поста <div class="checktext"><input type="checkbox" id="on_thumbnail" name="on_thumbnail" <?=($main[0]->on_thumbnail == 1) ? 'checked="checked"' : ''?>><label for="on_thumbnail">Включить в rss миниатюру поста (ширина не менее 240 пикселей, длина не менее 300 пикселей)</label></div></div>
<div class="adminp9chec">Краткое описание <div class="checktext"><input type="checkbox" id="on_description" name="on_description" <?=($main[0]->on_description == 1) ? 'checked="checked"' : ''?>><label for="on_description">Включить в rss краткое описание поста/одиночной статьи</label></div></div>
<div class="adminp9chec yandex_genre_janr">Жанр публикации <div class="checktext"><input type="checkbox" id="on_yandex_genre" name="on_yandex_genre" <?=($main[0]->on_yandex_genre == 1) ? 'checked="checked"' : ''?>><label for="on_yandex_genre">Включить в rss жанр публикации</label></div></div>
<div class="adminp9select yandex_genre_tip">Тип жанра публикации <select name="yandex_genre">
<option value="lenta" <?=($main[0]->yandex_genre == "lenta") ? 'selected="selected"' : ''?>>Короткое новостное сообщение (50–80 символов)</option>
<option value="message" <?=($main[0]->yandex_genre == "message") ? 'selected="selected"' : ''?>>Более развернутое новостное сообщение</option>
<option value="article" <?=($main[0]->yandex_genre == "article") ? 'selected="selected"' : ''?>>Статья</option>
<option value="interview" <?=($main[0]->yandex_genre == "interview") ? 'selected="selected"' : ''?>>Интервью</option>
</select></div>
<div class="adminp9chec">Автор <div class="checktext"><input type="checkbox" id="on_author" name="on_author" <?=($main[0]->on_author == 1) ? 'checked="checked"' : ''?>><label for="on_author">Включить в rss</label></div></div>
</div>
</div>
<br>
<input class="adminp5" class="butonss" type="submit" value="Сгенерировать rss файл" name="but_createrss">
</form>
</div>
</div>
</div>
</div>





<?php

if (isset($_POST["but_createrss"]))     {


function clear($ftexts, $length='none') {
$ftexts = strip_tags($ftexts);
$ftexts = preg_replace("/\n/", " ", $ftexts);
$ftexts = trim(preg_replace("/\s+/", " ", $ftexts));
if ($length=='none') { return $ftexts; }
else { $ftexts = mb_substr($ftexts, 0, $length, 'UTF-8'); return $ftexts; }
}


$on_post = (isset($_POST['on_post'])) ? 1 : 0;
$on_page = (isset($_POST['on_page'])) ? 1 : 0;
$on_thumbnail = (isset($_POST['on_thumbnail'])) ? 1 : 0;
$on_description = (isset($_POST['on_description'])) ? 1 : 0;
$on_yandex_genre = (isset($_POST['on_yandex_genre'])) ? 1 : 0;
$on_author = (isset($_POST['on_author'])) ? 1 : 0;
$wpdb->update('anblog_turboya',	array('title' => clear($_POST['title'], 200), 'link' => trim($_POST['link']), 'description' => clear($_POST['description'], 150), 'ya_analytic' => trim($_POST['ya_analytic']), 'on_post' => $on_post, 'on_page' => $on_page, 'on_thumbnail' => $on_thumbnail, 'on_description' => $on_description, 'on_yandex_genre' => $on_yandex_genre, 'yandex_genre' => $_POST['yandex_genre'], 'on_author' => $on_author, 'file_name' => trim($_POST['file_name'])), array('id' => 1));


$rss = '<?xml version="1.0" encoding="windows-1251"?>
  <rss
  xmlns:yandex="http://news.yandex.ru"
  xmlns:media="http://search.yahoo.com/mrss/"
  version="2.0">
    <channel>
      <title>'.clear($_POST['title'], 200).'</title>
      <link>'.trim($_POST['link']).'/</link>
      <description>'.clear($_POST['description'], 150).'</description>';
      $rss .= (!empty($_POST['ya_analytic'])) ? '
      <yandex:analytics
        type="Yandex"
        id="'.trim($_POST['ya_analytic']).'">
      </yandex:analytics>' : '';

$where = 'WHERE post_status = "publish"';
if (isset($_POST['on_post']) && isset($_POST['on_page'])) { $where .= ' AND (post_type = "post" OR post_type = "page")'; }
else if(isset($_POST['on_page']))                         { $where .= ' AND post_type = "page"'; }
else                                                      { $where .= ' AND post_type = "post"'; }


$items = $wpdb->get_results("SELECT * FROM wp_posts $where order by id DESC");
if (!empty($items)) foreach ($items as $item) {


$thumbnail_id  = $wpdb->get_results("SELECT * FROM wp_postmeta where post_id='".$item->ID."' AND meta_key='_thumbnail_id'");
$thumbnail_url = $wpdb->get_results("SELECT * FROM wp_posts where ID='".$thumbnail_id[0]->meta_value."'");


$author_name = $wpdb->get_results("SELECT * FROM wp_users where ID='".$item->post_author."' OR id='".$item->post_author."'");


        $post_content = clear($item->post_content);
        if(!empty($post_content)) {
        $rss .= '
          <item turbo="true">';
            $rss .= '
            <title>'.clear($item->post_title, 200).'</title>';
            $rss .= '
            <link>'.trim($_POST['link']).'/'.$item->post_name.'</link>';
            $rss .= (isset($_POST['on_description'])) ? '
            <description>'.clear($item->post_content, 150).'</description>' : '';
            $rss .= (isset($_POST['on_author'])) ? '
            <author>'.$author_name[0]->user_nicename.'</author>' : '';
            if(isset($_POST['on_thumbnail']) && !empty($thumbnail_url[0]->guid)) {
            $rss .= '
            <enclosure
              url="'.$thumbnail_url[0]->guid.'"
              type="'.$thumbnail_url[0]->post_mime_type.'"/>';}
            $rss .= '
            <pubDate>'.date(DATE_RFC822, strtotime($item->post_date)).'</pubDate>';
            $rss .= (isset($_POST['on_yandex_genre'])) ? '
            <yandex:genre>'.$_POST['yandex_genre'].'</yandex:genre>' : '';
            $rss .= '
            <yandex:full-text>'.clear($item->post_content).'</yandex:full-text>';
            $rss .= '
          </item>';
          }
}

$rss .= '
    </channel>
  </rss>';



@unlink($_SERVER['DOCUMENT_ROOT'].'/'.trim($_POST['file_name']));

$rss = iconv("UTF-8", "Windows-1251", $rss);
file_put_contents($_SERVER['DOCUMENT_ROOT'].'/'.trim($_POST['file_name']), $rss);
echo '<script>window.location="";</script>';
}
?>